//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_UAIL_MACRO_DEFINITIONS__
#define __EZ_UAIL_MACRO_DEFINITIONS__

//############################################################################
#include "ez_uail_includes.hpp"

//############################################################################
#define    LASERBOY_VERSION               "LaserBoy 11-14-2008"
//----------------------------------------------------------------------------
#define    LASERBOY_CFG_FILE              "LaserBoy.wtf"
//----------------------------------------------------------------------------
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-06-03-2008"
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-07-15-2008"
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-07-17-2008"
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-07-24-2008"
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-08-28-2008"
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-09-03-2008"
//#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-10-10-2008"
#define    LASERBOY_CFG_VERSION           "LaserBoy.wtf-11-11-2008"
//----------------------------------------------------------------------------
//#define    LASERBOY_WAVE_VERSION          "LaserBoy06072008"
//#define    LASERBOY_WAVE_VERSION          "LaserBoy07132008"
//#define    LASERBOY_WAVE_VERSION          "LaserBoy10102008"
#define    LASERBOY_WAVE_VERSION          "LaserBoy11112008"
//----------------------------------------------------------------------------
#define    EZ_UAIL_FRAME_SHARE            (string("./ild/"      ))
#define    EZ_UAIL_FONT_SHARE             (string("./fonts/"    ))
#define    EZ_UAIL_PALETTE_SHARE          (string("./pal/"      ))
#define    EZ_UAIL_WAVE_SHARE             (string("./wav/"      ))
#define    EZ_UAIL_SPLIT_WAVE_SHARE       (string("./wav/split/"))
#define    EZ_UAIL_ADAT_SHARE             (string("./wav/ADAT/" ))
#define    EZ_UAIL_DXF_SHARE              (string("./dxf/"      ))
#define    EZ_UAIL_BMP_SHARE              (string("./bmp/"      ))
#define    EZ_UAIL_CPP_SHARE              (string("./cpp/"      ))
//----------------------------------------------------------------------------
#define    EZ_UAIL_OK                     0
#define    EZ_UAIL_BAD_HEADER             1
#define    EZ_UAIL_EOF_ERROR              2
#define    EZ_UAIL_FILE_OPEN_FAILED       4
#define    EZ_UAIL_UNKNOWN_FORMAT         8
#define    EZ_UAIL_INCOMPATIBLE_FORMATS   16
#define    EZ_COLOR_POINT_MISSMATCH       32
//----------------------------------------------------------------------------
#define    EZ_UAIL_FORMAT_0_1             1
#define    EZ_UAIL_FORMAT_2               2
#define    EZ_UAIL_FORMAT_3               4
#define    EZ_UAIL_FORMAT_4_5             8
//----------------------------------------------------------------------------
#define    EZ_WAVE_POSITIVE               1
#define    EZ_WAVE_END_OF_FRAME           2
#define    EZ_WAVE_UNIQUE_FRAME           4
#define    EZ_WAVE_UNIQUE_POINT           8
#define    EZ_WAVE_OFFSETS                16
#define    EZ_WAVE_OPTIMIZED              32
#define    EZ_WAVE_SIGNAL_MATRIX          64
#define    EZ_SIGNAL_BIT_RESOLUTION       128
//----------------------------------------------------------------------------
#define    EZ_SIGNAL_UNDEFINED            0x00
//----------------------------------------------------------------------------
#define    EZ_SIGNAL_X_POSITION           0x10
#define    EZ_SIGNAL_Y_POSITION           0x11
#define    EZ_SIGNAL_Z_POSITION           0x12
#define    EZ_SIGNAL_DX_POSITION          0x13
#define    EZ_SIGNAL_DY_POSITION          0x14
//----------------------------------------------------------------------------
#define    EZ_SIGNAL_BEAM_WIDTH           0x20
//----------------------------------------------------------------------------
#define    EZ_SIGNAL_RED_TTL              0x30
#define    EZ_SIGNAL_RED_ANALOG           0x31
#define    EZ_SIGNAL_YELLOW_TTL           0x32
#define    EZ_SIGNAL_YELLOW_ANALOG        0x33
#define    EZ_SIGNAL_GREEN_TTL            0x34
#define    EZ_SIGNAL_GREEN_ANALOG         0x35
#define    EZ_SIGNAL_BLUE_TTL             0x36
#define    EZ_SIGNAL_BLUE_ANALOG          0x37
#define    EZ_SIGNAL_VIOLET_TTL           0x38
#define    EZ_SIGNAL_VIOLET_ANALOG        0x39
#define    EZ_SIGNAL_MONO_TTL             0x3a
#define    EZ_SIGNAL_MONO_ANALOG          0x3b
//----------------------------------------------------------------------------
#define    EZ_SIGNAL_AUDIO_SMTPE          0x40
#define    EZ_SIGNAL_AUDIO_MONO           0x41
#define    EZ_SIGNAL_AUDIO_LEFT           0x42
#define    EZ_SIGNAL_AUDIO_RIGHT          0x43
#define    EZ_SIGNAL_AUDIO_CENTER         0x44
#define    EZ_SIGNAL_AUDIO_SUB            0x45
#define    EZ_SIGNAL_AUDIO_S_LEFT         0x46
#define    EZ_SIGNAL_AUDIO_S_RIGHT        0x47
#define    EZ_SIGNAL_AUDIO_R_LEFT         0x48
#define    EZ_SIGNAL_AUDIO_R_RIGHT        0x49
//----------------------------------------------------------------------------
#define    EZ_LSB_NOT_USED                0
#define    EZ_LSB_BLANKING                1
#define    EZ_LSB_END_OF_FRAME            2
#define    EZ_LSB_UNIQUE_FRAME            3
#define    EZ_LSB_UNIQUE_POINT            4
//----------------------------------------------------------------------------
#define    EZ_IN_BOUNDS                   0
#define    EZ_OUT_POS_X                   1
#define    EZ_OUT_NEG_X                  -1
#define    EZ_OUT_POS_Y                   2
#define    EZ_OUT_NEG_Y                  -2
#define    EZ_OUT_POS_Z                   3
#define    EZ_OUT_NEG_Z                  -3
//----------------------------------------------------------------------------
#define    EZ_UAIL_3D_VECTOR              0
#define    EZ_UAIL_2D_VECTOR              1
#define    EZ_UAIL_PALETTE                2
#define    EZ_UAIL_COLOR_TABLE            3
#define    EZ_UAIL_3D_COLOR_VECTOR        4
#define    EZ_UAIL_2D_COLOR_VECTOR        5
//----------------------------------------------------------------------------
#define    EZ_TRUE_COLOR                 -1
#define    EZ_UAIL_DEFAULT                0
#define    EZ_X29                         1
#define    EZ_UAIL_STANDARD               2
#define    EZ_DXF                         3
#define    EZ_EZFB_HUES                   4
#define    EZ_REDGREEN                    5
#define    EZ_EZFB_332                    6
#define    EZ_EZFB_323                    7
#define    EZ_EZFB_233                    8
#define    EZ_REDS                        9
#define    EZ_GREENS                      10
#define    EZ_BLUES                       11
#define    EZ_YELLOWS                     12
#define    EZ_MAGENTAS                    13
#define    EZ_CYANS                       14
#define    EZ_GRAYS                       15
#define    EZ_BUILT_IN_PALETTES           16
//----------------------------------------------------------------------------
#define    EZ_UAIL_SHOW_POINTS            1
#define    EZ_UAIL_SHOW_BLANKS            2
#define    EZ_UAIL_SHOW_SELECT            4
#define    EZ_UAIL_SHOW_ORIGIN            8
//----------------------------------------------------------------------------
#define    EZ_UAIL_SELECTED_POINT         1   // 0000 0001
#define    EZ_UAIL_UNIQUE_POINT           32  // 0010 0000
#define    EZ_UAIL_BLANKING_BIT           64  // 0100 0000
#define    EZ_UAIL_LAST_POINT             128 // 1000 0000
//----------------------------------------------------------------------------
#define    EZ_PALETTE_MAX                 256
//----------------------------------------------------------------------------
#define    EZ_UAIL_DEBUG_MESSAGES         0
//----------------------------------------------------------------------------
#define    EZ_STATS_DISPLAY_OFFSET        4
//----------------------------------------------------------------------------
#define    EZ_SHORT_SPAN                  65536
#define    EZ_MAX_USHORT                  65535
#define    EZ_MAX_SHORT                   32767
#define    EZ_MIN_SHORT                  -32768
#define    EZ_HALF_SHORT                  16384
//----------------------------------------------------------------------------
#define    EZFB_BMP_FILE_HEADER_SIZE       54
#define    EZFB_BITS_IN_SHORT              16
#define    EZFB_BITS_IN_CHAR               8
//----------------------------------------------------------------------------
#define    BMP                            (EZI->bmp           )
#define    BACKGROUND                     (EZI->background    )
#define    BACKGROUND_BMP                 (EZI->background_bmp)
//----------------------------------------------------------------------------
#define    EZ_UAIL_CUBE                   1
#define    EZ_UAIL_SPHERE                 2
#define    EZ_UAIL_7_8THS_CUBE            3
#define    EZ_UAIL_7_8THS_SPHERE          4
//----------------------------------------------------------------------------
#ifndef O_BINARY
#define O_BINARY 0
#endif

//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
